/*----- PROTECTED REGION ID(TestSpectrumWriting.cpp) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        TestSpectrumWriting.cpp
//
// description : C++ source for the TestSpectrumWriting class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               TestSpectrumWriting are implemented in this file.
//
//
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
// Copyright (C): 2024
//                European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                France
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include "TestSpectrumWriting.h"
#include "TestSpectrumWritingClass.h"
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	TestSpectrumWriting.cpp

/**
 *  TestSpectrumWriting class description:
 *    
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//================================================================
//  State         |  Inherited (no method)
//  Status        |  Inherited (no method)
//================================================================

//================================================================
//  Attributes managed is:
//================================================================
//  RWFloatSpectrum  |  Tango::DevFloat	Spectrum  ( max = 10)
//================================================================

namespace TestSpectrumWriting_ns
{
/*----- PROTECTED REGION ID(TestSpectrumWriting::namespace_starting) ENABLED START -----*/
/* clang-format on */
//	static initializations
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	TestSpectrumWriting::namespace_starting

//--------------------------------------------------------
/**
 *	Method     : TestSpectrumWriting::TestSpectrumWriting()
 *	Description: Constructors for a Tango device
 *                implementing the classTestSpectrumWriting
 */
//--------------------------------------------------------
TestSpectrumWriting::TestSpectrumWriting(Tango::DeviceClass *cl, std::string &s)
 : TANGO_BASE_CLASS(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(TestSpectrumWriting::constructor_1) ENABLED START -----*/
	/* clang-format on */
	init_device();
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TestSpectrumWriting::constructor_1
}
//--------------------------------------------------------
TestSpectrumWriting::TestSpectrumWriting(Tango::DeviceClass *cl, const char *s)
 : TANGO_BASE_CLASS(cl, s)
{
	/*----- PROTECTED REGION ID(TestSpectrumWriting::constructor_2) ENABLED START -----*/
	/* clang-format on */
	init_device();
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TestSpectrumWriting::constructor_2
}
//--------------------------------------------------------
TestSpectrumWriting::TestSpectrumWriting(Tango::DeviceClass *cl, const char *s, const char *d)
 : TANGO_BASE_CLASS(cl, s, d)
{
	/*----- PROTECTED REGION ID(TestSpectrumWriting::constructor_3) ENABLED START -----*/
	/* clang-format on */
	init_device();
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TestSpectrumWriting::constructor_3
}
//--------------------------------------------------------
TestSpectrumWriting::~TestSpectrumWriting()
{
	delete_device();
}

//--------------------------------------------------------
/**
 *	Method     : TestSpectrumWriting::delete_device()
 *	Description: will be called at device destruction or at init command
 */
//--------------------------------------------------------
void TestSpectrumWriting::delete_device()
{
	DEBUG_STREAM << "TestSpectrumWriting::delete_device() " << device_name << std::endl;
	/*----- PROTECTED REGION ID(TestSpectrumWriting::delete_device) ENABLED START -----*/
	/* clang-format on */
	//	Delete device allocated objects
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TestSpectrumWriting::delete_device
	delete[] attr_RWFloatSpectrum_read;
}

//--------------------------------------------------------
/**
 *	Method     : TestSpectrumWriting::init_device()
 *	Description: will be called at device initialization.
 */
//--------------------------------------------------------
void TestSpectrumWriting::init_device()
{
	DEBUG_STREAM << "TestSpectrumWriting::init_device() create device " << device_name << std::endl;
	/*----- PROTECTED REGION ID(TestSpectrumWriting::init_device_before) ENABLED START -----*/
	/* clang-format on */
	//	Initialization before get_device_property() call
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TestSpectrumWriting::init_device_before

	//	No device property to be read from database

	attr_RWFloatSpectrum_read = new Tango::DevFloat[10];
	/*----- PROTECTED REGION ID(TestSpectrumWriting::init_device) ENABLED START -----*/
	/* clang-format on */
	//	Initialize device
	Tango::WAttribute &RWFloatAttr = dev_attr->get_w_attr_by_name( "RWFloatSpectrum" );
	std::vector<float> float_input={1,2,3};
	RWFloatAttr.set_write_value(float_input.data(),3,1);
	attr_RWFloatSpectrum_read_length = float_input.size();
	for(size_t i = 0; i < float_input.size(); i++)
	{
		attr_RWFloatSpectrum_read[i] = float_input[i];
	}
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TestSpectrumWriting::init_device
}


//--------------------------------------------------------
/**
 *	Method     : TestSpectrumWriting::always_executed_hook()
 *	Description: method always executed before any command is executed
 */
//--------------------------------------------------------
void TestSpectrumWriting::always_executed_hook()
{
	DEBUG_STREAM << "TestSpectrumWriting::always_executed_hook()  " << device_name << std::endl;
	/*----- PROTECTED REGION ID(TestSpectrumWriting::always_executed_hook) ENABLED START -----*/
	/* clang-format on */
	//	code always executed before all requests
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TestSpectrumWriting::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method     : TestSpectrumWriting::read_attr_hardware()
 *	Description: Hardware acquisition for attributes
 */
//--------------------------------------------------------
void TestSpectrumWriting::read_attr_hardware(TANGO_UNUSED(std::vector<long> &attr_list))
{
	DEBUG_STREAM << "TestSpectrumWriting::read_attr_hardware(std::vector<long> &attr_list) entering... " << std::endl;
	/*----- PROTECTED REGION ID(TestSpectrumWriting::read_attr_hardware) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TestSpectrumWriting::read_attr_hardware
}
//--------------------------------------------------------
/**
 *	Method     : TestSpectrumWriting::write_attr_hardware()
 *	Description: Hardware writing for attributes
 */
//--------------------------------------------------------
void TestSpectrumWriting::write_attr_hardware(TANGO_UNUSED(std::vector<long> &attr_list))
{
	DEBUG_STREAM << "TestSpectrumWriting::write_attr_hardware(std::vector<long> &attr_list) entering... " << std::endl;
	/*----- PROTECTED REGION ID(TestSpectrumWriting::write_attr_hardware) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TestSpectrumWriting::write_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute RWFloatSpectrum related method
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Spectrum max = 10
 */
//--------------------------------------------------------
void TestSpectrumWriting::read_RWFloatSpectrum(Tango::Attribute &attr)
{
	DEBUG_STREAM << "TestSpectrumWriting::read_RWFloatSpectrum(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(TestSpectrumWriting::read_RWFloatSpectrum) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	attr.set_value(attr_RWFloatSpectrum_read, attr_RWFloatSpectrum_read_length);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TestSpectrumWriting::read_RWFloatSpectrum
}
//--------------------------------------------------------
/**
 *	Write attribute RWFloatSpectrum related method
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Spectrum max = 10
 */
//--------------------------------------------------------
void TestSpectrumWriting::write_RWFloatSpectrum(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "TestSpectrumWriting::write_RWFloatSpectrum(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve number of write values
	int	w_length = attr.get_write_value_length();

	//	Retrieve pointer on write values (Do not delete !)
	const Tango::DevFloat	*w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(TestSpectrumWriting::write_RWFloatSpectrum) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	std::cout<<"In write_RWFloatSpectrum:"<<std::endl;
	for (int j=0;j<w_length;j++)
	{
        std::cout<<"w_val["<<j<<"] = "<<w_val[j]<<" ";
        attr_RWFloatSpectrum_read[j] = w_val[j];
	}
	std::cout << std::endl;
	attr_RWFloatSpectrum_read_length = w_length;
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TestSpectrumWriting::write_RWFloatSpectrum
}

//--------------------------------------------------------
/**
 *	Method     : TestSpectrumWriting::add_dynamic_attributes()
 *	Description: Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void TestSpectrumWriting::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(TestSpectrumWriting::add_dynamic_attributes) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code to create and add dynamic attributes if any
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TestSpectrumWriting::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method     : TestSpectrumWriting::add_dynamic_commands()
 *	Description: Create the dynamic commands if any
 *                for specified device.
 */
//--------------------------------------------------------
void TestSpectrumWriting::add_dynamic_commands()
{
	/*----- PROTECTED REGION ID(TestSpectrumWriting::add_dynamic_commands) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code to create and add dynamic commands if any
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TestSpectrumWriting::add_dynamic_commands
}

/*----- PROTECTED REGION ID(TestSpectrumWriting::namespace_ending) ENABLED START -----*/
/* clang-format on */
//	Additional Methods
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	TestSpectrumWriting::namespace_ending
} //	namespace
