/*----- PROTECTED REGION ID(TestSpectrumWriting.h) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        TestSpectrumWriting.h
//
// description : Include file for the TestSpectrumWriting class
//
//
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
// Copyright (C): 2024
//                European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                France
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef TestSpectrumWriting_H
#define TestSpectrumWriting_H

#include <tango.h>

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	TestSpectrumWriting.h

#ifdef TANGO_LOG
	// cppTango after c934adea (Merge branch 'remove-cout-definition' into 'main', 2022-05-23)
	// nothing to do
#else
	// cppTango 9.3-backports and older
	#define TANGO_LOG       cout
	#define TANGO_LOG_INFO  cout2
	#define TANGO_LOG_DEBUG cout3
#endif // TANGO_LOG

/**
 *  TestSpectrumWriting class description:
 *    
 */


namespace TestSpectrumWriting_ns
{
/*----- PROTECTED REGION ID(TestSpectrumWriting::Additional Class Declarations) ENABLED START -----*/
/* clang-format on */
//	Additional Class Declarations
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	TestSpectrumWriting::Additional Class Declarations

class TestSpectrumWriting : public TANGO_BASE_CLASS
{

/*----- PROTECTED REGION ID(TestSpectrumWriting::Data Members) ENABLED START -----*/
/* clang-format on */
//	Add your own data members
public:
	long attr_RWFloatSpectrum_read_length;
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	TestSpectrumWriting::Data Members


//	Attribute data members
public:
	Tango::DevFloat	*attr_RWFloatSpectrum_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	TestSpectrumWriting(Tango::DeviceClass *cl,std::string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	TestSpectrumWriting(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	TestSpectrumWriting(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~TestSpectrumWriting();


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();


//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method     : TestSpectrumWriting::read_attr_hardware()
	 *	Description: Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(std::vector<long> &attr_list);
	//--------------------------------------------------------
	/*
	 *	Method     : TestSpectrumWriting::write_attr_hardware()
	 *	Description: Hardware writing for attributes.
	 */
	//--------------------------------------------------------
	virtual void write_attr_hardware(std::vector<long> &attr_list);

/**
 *	Attribute RWFloatSpectrum related methods
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Spectrum max = 10
 */
	virtual void read_RWFloatSpectrum(Tango::Attribute &attr);
	virtual void write_RWFloatSpectrum(Tango::WAttribute &attr);
	virtual bool is_RWFloatSpectrum_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method     : TestSpectrumWriting::add_dynamic_attributes()
	 *	Description: Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:


	//--------------------------------------------------------
	/**
	 *	Method     : TestSpectrumWriting::add_dynamic_commands()
	 *	Description: Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(TestSpectrumWriting::Additional Method prototypes) ENABLED START -----*/
/* clang-format on */
//	Additional Method prototypes
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	TestSpectrumWriting::Additional Method prototypes
};

/*----- PROTECTED REGION ID(TestSpectrumWriting::Additional Classes Definitions) ENABLED START -----*/
/* clang-format on */
//	Additional Classes Definitions
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	TestSpectrumWriting::Additional Classes Definitions

}	//	End of namespace

#endif   //	TestSpectrumWriting_H
